/***************************************************************************
 * tabtracksubject.h: implementation of TabTrack class
 *
 * This file is part of KTabEdit, a KDE tabulature editor
 *
 * copyright (C) 2007- the KTabEdit development team <mrgwen@gmail.com>
 ***************************************************************************/

/***************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * See the file COPYING for more information.
 ***************************************************************************/

#ifndef TABTRACKSUBJECT_H
#define TABTRACKSUBJECT_H

#include <QList>

class TabTrackObserver;

class TabTrackSubject
{
public:
	TabTrackSubject();
	virtual ~TabTrackSubject();
	
	virtual void attach(TabTrackObserver* o);
	virtual void detach(TabTrackObserver* o);
	
	virtual void notifyNoteEffectChanged(int bar, int time, int chord);
	virtual void notifyNoteChanged(int bar, int time, int note);
	virtual void notifyTimeChordChanged(int bar, int time);
	virtual void notifyTimeEffectChanged(int bar, int time);
	virtual void notifyTimeChanged(int bar, int time);
	virtual void notifyBarPropertyChanged(int bar);
	virtual void notifyBarMixChanged(int bar);
	virtual void notifyBarChanged(int bar);
	virtual void notifyTrackPropertyChanged();
	virtual void notifyTrackChanged();
	
private:
	typedef QList<TabTrackObserver*>::iterator iterator;
	
	QList<TabTrackObserver*> mObserver;
};

#endif
